/*************************************************************************
*
* YPOPs!
*
* YPOPs! is an application that provides POP3 access to Yahoo! Mail.
* You do not need to enable POP3 access with Yahoo! to use this program.
* This program works within the license agreement of Yahoo! to provide
* you with POP3 access.
*
* YPOPs! emulates a POP3 mail server and should work with most of the
* email clients. Since YPOPs! is not a full-fledged POP3 mail server
* you might find it not working with all mail clients. Do keep us informed
* about such mail clients so that we can enhance YPOPs!
*
* Official Website: http://yahoopops.sourceforge.net
*
*-------------------------------------------------------------------------
*
* Name    :	DataHolder.h
*
* Purpose : Retrieve/Save the configured settings
*
* Authors : Anuj Seth
* 			K.Shyam
*
* License : GNU Public License (Version 2 or later)
*
*-------------------------------------------------------------------------
*
* THIS SOFTWARE IS PROVIDED ``AS IS'' BY THE AUTHORS AND INDEPENDENT
* CONTRIBUTORS AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
* PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR 
* CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
* EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
* PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
* LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*************************************************************************/
#ifndef _DATAHOLDER_H_
#define _DATAHOLDER_H_

#include "Defines.h"

enum EMAIL_CATEGORY { EC_ALL = 'a', EC_UNREAD = 'u', EC_FLAGGED = 'f'};

class CDataHolder  
{
public:
	CDataHolder();
	virtual ~CDataHolder();
    CStringEx stripQ(const char *strA);
    int Load();
	void Save();
    void DumpToLog();

	// Persistent Data
	BOOL			m_bUseMD5;
	BOOL			m_bPlain;
	BOOL			m_bSecureMode;


	CStringEx		m_strHttpProxyHost;
	UINT			m_nHttpProxyPort;
	CStringEx		m_strHttpsProxyHost;
	UINT			m_nHttpsProxyPort;
	BOOL			m_bUseProxy;
	int				m_nUserAgent;
	CStringEx		m_strUserAgent;
	UINT			m_nMaxEmails;
	BOOL			m_bEmptyTrash;
	BOOL			m_bEmptyBulkMail;
	BOOL			m_bBulkMail;
	BOOL			m_bInbox;
	EMAIL_CATEGORY	m_nEmailCategory;
	BOOL			m_bProxyAuth;
	CStringEx		m_strProxyAuthPassword;
	CStringEx		m_strProxyAuthUsername;
	BOOL			m_bQuietMode;
	CStringEx		m_strNetworkIPAddr;
	u_short			m_nNetworkPort;
	BOOL			m_bLeaveUnread;
	BOOL			m_bAutoStartWithWindows;
	u_short			m_nSmtpPort;
	CStringEx       m_strFolderList;
    BOOL            m_bAlwaysOnTop;
    BOOL            m_bEnableSmtp;
    BOOL            m_bSaveEmailCopy;
    BOOL            m_bEnableUIDL;
    BOOL            m_bHideTrayIcon;
    BOOL            m_bIgnoreSize;
    BOOL            m_bApplyLimit;

	UINT			m_nCookieTimeout;

	// Activity Log
	BOOL			m_bCreateLog;
	BOOL			m_bLimitLog;
	UINT			m_nLogLevel;
	UINT			m_nLogSize;
};

#endif

